{"The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS"
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is BeniGrad.pas.

The Initial Developer of the Original Code is Benito van der Zander.
All Rights Reserved.

Alternatively, the contents of this file may be used under the terms
of the Gnu Public License Version 2 or higher license (the  "GPL 2 License"), in which case the
provisions of GPL 2 License are applicable instead of those
above. If you wish to allow use of your version of this file only
under the terms of the GPL 2 License and not to allow others to use
your version of this file under the MPL, indicate your decision by
deleting the provisions above and replace them with the notice and
other provisions required by the GPL 2 License. If you do not delete
the provisions above, a recipient may use your version of this file
under either the MPL or the GPL 2 License."}
unit BeniGrad;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,

  ExtCtrls;
type TColorArray = array[1..20] of TColor;
type
  TBeniGrad = class(TGraphicControl)
  private
    c1, c2, c3, c4, c5, c6, c7, c8, c9, c10, c11, c12, c13, c14, c15, c16, c17, c18, c19, c20: TColor;
    cco: TColorArray;
    ges: integer;
    { Private-Deklarationen}
    procedure WC1(value: TColor);
    procedure WC2(value: TColor);
    procedure WC3(value: TColor);
    procedure WC4(value: TColor);
    procedure WC5(value: TColor);
    procedure WC6(value: TColor);
    procedure WC7(value: TColor);
    procedure WC8(value: TColor);
    procedure WC9(value: TColor);
    procedure WC10(value: TColor);
    procedure WC11(value: TColor);
    procedure WC12(value: TColor);
    procedure WC13(value: TColor);
    procedure WC14(value: TColor);
    procedure WC15(value: TColor);
    procedure WC16(value: TColor);
    procedure WC17(value: TColor);
    procedure WC18(value: TColor);
    procedure WC19(value: TColor);
    procedure WC20(value: TColor);
    procedure WG1(value: integer);
    procedure malen;
  protected
    { Protected-Deklarationen}
  public
    { Public-Deklarationen}
    constructor create(aComponent: TComponent); override;
    procedure Paint; override;


  published
    { Published-Deklarationen }
    property Color1: TColor read c1 write wc1;
    property Color2: TColor read c2 write wc2;
    property Color3: TColor read c3 write wc3;
    property Color4: TColor read c4 write wc4;
    property Color5: TColor read c5 write wc5;
    property Color6: TColor read c6 write wc6;
    property Color7: TColor read c7 write wc7;
    property Color8: TColor read c8 write wc8;
    property Color9: TColor read c9 write wc9;
    property Color10: TColor read c10 write wc10;
    property Color11: TColor read c11 write wc11;
    property Color12: TColor read c12 write wc12;
    property Color13: TColor read c13 write wc13;
    property Color14: TColor read c14 write wc14;
    property Color15: TColor read c15 write wc15;
    property Color16: TColor read c16 write wc16;
    property Color17: TColor read c17 write wc17;
    property Color18: TColor read c18 write wc18;
    property Color19: TColor read c19 write wc19;
    property Color20: TColor read c20 write wc20;
    property VerwendeteFarben: integer read ges write wg1;
  end;

procedure Register;

implementation
procedure TBeniGrad.WC1(value: TColor); begin c1 := value; cco[1] := value; malen; end;
procedure TBeniGrad.WC2(value: TColor); begin c2 := value; cco[2] := value; malen; end;
procedure TBeniGrad.WC3(value: TColor); begin c3 := value; cco[3] := value; malen; end;
procedure TBeniGrad.WC4(value: TColor); begin c4 := value; cco[4] := value; malen; end;
procedure TBeniGrad.WC5(value: TColor); begin c5 := value; cco[5] := value; malen; end;
procedure TBeniGrad.WC6(value: TColor); begin c6 := value; cco[6] := value; malen; end;
procedure TBeniGrad.WC7(value: TColor); begin c7 := value; cco[7] := value; malen; end;
procedure TBeniGrad.WC8(value: TColor); begin c8 := value; cco[8] := value; malen; end;
procedure TBeniGrad.WC9(value: TColor); begin c9 := value; cco[9] := value; malen; end;
procedure TBeniGrad.WC10(value: TColor); begin c10 := value; cco[10] := value; malen; end;
procedure TBeniGrad.WC11(value: TColor); begin c11 := value; cco[11] := value; malen; end;
procedure TBeniGrad.WC12(value: TColor); begin c12 := value; cco[12] := value; malen; end;
procedure TBeniGrad.WC13(value: TColor); begin c13 := value; cco[13] := value; malen; end;
procedure TBeniGrad.WC14(value: TColor); begin c14 := value; cco[14] := value; malen; end;
procedure TBeniGrad.WC15(value: TColor); begin c15 := value; cco[15] := value; malen; end;
procedure TBeniGrad.WC16(value: TColor); begin c16 := value; cco[16] := value; malen; end;
procedure TBeniGrad.WC17(value: TColor); begin c17 := value; cco[17] := value; malen; end;
procedure TBeniGrad.WC18(value: TColor); begin c18 := value; cco[18] := value; malen; end;
procedure TBeniGrad.WC19(value: TColor); begin c19 := value; cco[19] := value; malen; end;
procedure TBeniGrad.WC20(value: TColor); begin c20 := value; cco[20] := value; malen; end;
procedure TBeniGrad.WG1(value: integer); begin ges := value; malen; end;

constructor TBEniGrad.create(aComponent: TComponent);
begin
  inherited create(aComponent);
  c1 := clBlue;
  cco[1] := clBlue;

  ges := 2;
  Width := 150;
  Height := 25;

end;
procedure TBeniGrad.Paint;
begin
  inherited Paint;

  malen;
end;

procedure TBeniGrad.malen;
var c: TColorArray;
  a, cc: integer;
  r, g, b, t1, t2, t3: double;
  r2, g2, b2, tt: integer;
begin
  inherited;
  tt := 1;
  c := cco;
  for cc := 1 to ges - 1 do begin
    r := GetRValue(c[cc]); g := GetGValue(c[cc]); b := GetBValue(c[cc]);
    r2 := GetRValue(c[cc + 1]); g2 := GetGValue(c[cc + 1]); b2 := GetBValue(c[cc + 1]);
    t1 := abs(r - r2) / (width div (ges - 1));
    t2 := abs(g - g2) / (width div (ges - 1));
    t3 := abs(b - b2) / (width div (ges - 1));
    for a := tt to tt + width div (ges - 1) do begin
      if r < r2 then r := r + t1; if r > r2 then r := r - t1;
      if g < g2 then g := g + t2; if g > g2 then g := g - t2;
      if b < b2 then b := b + t3; if b > b2 then b := b - t3;
      c[cc] := RGB(trunc(r), trunc(g), trunc(b));
      canvas.pen.Color := c[cc];
      canvas.pen.Style := psSolid;

      canvas.moveTo(a, 0);
      canvas.LineTo(a, height);
    end;
    tt := tt + width div (ges - 1);
  end;
end;

procedure Register;
begin
  RegisterComponents('BeniBela', [TBeniGrad]);
end;

end.
